/////////////////////////////////////////////////////////
// mini_map spokoinbli
#ifdef GL_ES
precision mediump float;
#endif
varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform lowp sampler2D samplerBack;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
uniform mediump vec2 layoutStart;
uniform mediump vec2 layoutEnd;
uniform mediump float zoom;
uniform mediump float x;
uniform mediump float y;
uniform mediump float radius;



void main( void ) {
   mediump vec2 uv =  (vTex-srcOriginStart) / (srcOriginEnd - srcOriginStart);

   mediump vec2 layoutSize = abs(vec2(layoutEnd.x-layoutStart.x, (layoutEnd.y-layoutStart.y))); 

   mediump vec2 n = (uv - vec2(0.5)) * layoutSize; 

   mediump float d = distance(n, vec2(0.5)); 
   mediump float r = radius/2.;
   
   
   uv = (uv - vec2(x,y)) * (1.-zoom) + vec2(x,y);
  
   lowp vec4 texel = texture2D(samplerBack, vec2(uv.x,1.-uv.y));

    
   if (r <= d){
	  	discard;
	 	}

       gl_FragColor = texel;  
}


