﻿#version 300 es
/////////////////////////////////////////////////////////
// mini_map spokoinbli


#ifdef GL_FRAGMENT_PRECISION_HIGH
#define highmedp highp
#else
#define highmedp mediump
#endif

precision lowp float;

in mediump vec2 vTex;
out lowp vec4 outColor;
uniform lowp sampler2D samplerFront;
uniform lowp sampler2D samplerBack;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
uniform mediump vec2 layoutStart;
uniform mediump vec2 layoutEnd;
uniform mediump float zoom;
uniform mediump float x;
uniform mediump float y;
uniform mediump float radius;



void main( void ) {
    vec2 uv =  (vTex-srcOriginStart) / (srcOriginEnd - srcOriginStart);

    vec2 layoutSize = abs(vec2(layoutEnd.x-layoutStart.x, (layoutEnd.y-layoutStart.y))); 

    vec2 n = (uv - vec2(0.5)) * layoutSize; 

    float d = distance(n, vec2(0.5)); 
    float r = radius/2.;
   
   
    uv = (uv - vec2(x,y)) * (1.-zoom) + vec2(x,y);
  
    lowp vec4 texel = texture(samplerBack, vec2(uv.x,1.-uv.y));

    
    if (r <= d){
	   	discard;
	   	}

       outColor = texel;  
}


