
/////////////////////////////////////////////////////////
// mini_map spokoinbli
%%FRAGMENTINPUT_STRUCT%%
/* input struct contains the following fields:
fragUV : vec2<f32>
fragPos : vec4<f32>
fn c3_getBackUV(fragPos : vec2<f32>, texBack : texture_2d<f32>) -> vec2<f32>
fn c3_getDepthUV(fragPos : vec2<f32>, texDepth : texture_depth_2d) -> vec2<f32>
*/
%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

%%SAMPLERBACK_BINDING%% var samplerBack : sampler;
%%TEXTUREBACK_BINDING%% var textureBack : texture_2d<f32>;


struct ShaderParams {

 zoom : f32,
 x : f32,
 y : f32,
 radius : f32


};
%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;
/* gets replaced with:

struct ShaderParams {

	floatParam : f32,
	colorParam : vec3<f32>,
	// etc.

};

%//%SHADERPARAMS_BINDING%//% var<uniform> shaderParams : ShaderParams;
*/

%%C3PARAMS_STRUCT%%



@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
   var uv : vec2<f32> = (input.fragUV - c3Params.srcOriginStart) / (c3Params.srcOriginEnd - c3Params.srcOriginStart);

   var layoutSize : vec2<f32>= abs(vec2<f32>(c3Params.layoutEnd.x-c3Params.layoutStart.x, (c3Params.layoutEnd.y-c3Params.layoutStart.y))); 

    var n : vec2<f32> = (uv - vec2<f32>(0.5)) * layoutSize; 

    var d : f32 = distance(n, vec2<f32>(0.5)); 
   var r : f32 = shaderParams.radius/2.;
   
   
   uv = (uv - vec2<f32>(shaderParams.x,shaderParams.y)) * (1.-shaderParams.zoom) + vec2<f32>(shaderParams.x,shaderParams.y);
  
   var texel : vec4<f32> = textureSample(textureBack, samplerBack, vec2<f32>(uv.x,uv.y));

    
   if (r <= d){
	  	discard;
	 	}
 var output : FragmentOutput;
 output.color = texel;  
 return output; 
}


